rem -- initcaps.mcr

rem -- 1.1	Replaced ToBack: with ToMacro: for performance
rem --			Added feedback for erroneous input
rem --			Added support for non-English languages
rem --
rem -- 1.0	First cut

PROC macro:

	local x$(255)
	local alpha$(50)
	local inword%
	local i%
	local lentext%
	
	i%=1
	inword%=0
	alpha$="abcdefghijklmnopqrstuvwxyz"

	UseApp: ("Active")
	
	REM setup bring server
	SendKey: (right%, shift%, 1)
	if SrvPid%: <> CurrPid%:
		ToMacro:
		ToFront:
	endif
	SendKey: (left%, shift%, 1)
	
	x$=GetText$:
	lentext%=len(x$)
	
	if lentext%=0
		giPrint: ("No selection")
	elseif lentext%=255
		giPrint: ("Selection too large")
	else
		while (i% < lentext%)
			if inword%=0 and loc(alpha$, mid$(x$, i%, 1)) > 0
				x$=Left$(x$, i%-1) + Upper$(Mid$(x$, i%, 1)) + Right$(x$, lentext%-i%)
				inword%=1
			elseif loc(alpha$, mid$(x$, i%, 1)) = 0
				inword%=0
			endif
			
			i%=i%+1
		endwh

		Delete:
		PutText: (x$)

	endif

ENDP
